// RSSMU_GPS_ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSSMU_GPS_Example.h"
#include "RSSMU_GPS_ExampleDlg.h"
#include "resource.h"
#include "rssmu.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMU_GPS_ExampleDlg dialog

CRSSMU_GPS_ExampleDlg::CRSSMU_GPS_ExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRSSMU_GPS_ExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSSMU_GPS_ExampleDlg)
	m_Query = TRUE;
	m_Reset = TRUE;
	m_RFFreq = 1.575420E+9;
	m_RFLevel = -115.0;
	m_RFState = FALSE;
	m_ResName = _T("GPIB::28");
	m_GpsState = FALSE;
	m_SatDoppler = 0.0;
	m_SatId = 1;
	m_SatPower = 0.0;
	m_SatTime = 0;
	m_NavData = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRSSMU_GPS_ExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSSMU_GPS_ExampleDlg)
	DDX_Control(pDX, IDCANCEL, m_Exit);
	DDX_Control(pDX, IDAPPLY, m_Apply);
	DDX_Check(pDX, IDC_ID_QUERY, m_Query);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Text(pDX, IDC_RF_FREQ, m_RFFreq);
	DDX_Text(pDX, IDC_RF_LEVEL, m_RFLevel);
	DDX_Check(pDX, IDC_RF_STATE, m_RFState);
	DDX_Text(pDX, IDC_RESOURCE_DESCRIPTOR, m_ResName);
	DDX_Check(pDX, IDC_GPS_STATE, m_GpsState);
	DDX_Text(pDX, IDC_SATDOPPLER, m_SatDoppler);
	DDV_MinMaxDouble(pDX, m_SatDoppler, -100000., 100000.);
	DDX_Text(pDX, IDC_SATID, m_SatId);
	DDV_MinMaxInt(pDX, m_SatId, 1, 37);
	DDX_Text(pDX, IDC_SATPOWER, m_SatPower);
	DDV_MinMaxDouble(pDX, m_SatPower, -10., 10.);
	DDX_Text(pDX, IDC_SATTIME, m_SatTime);
	DDV_MinMaxInt(pDX, m_SatTime, 0, 1023000);
	DDX_CBIndex(pDX, IDC_NAVDATA, m_NavData);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRSSMU_GPS_ExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CRSSMU_GPS_ExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDAPPLY, OnApply)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMU_GPS_ExampleDlg message handlers

BOOL CRSSMU_GPS_ExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRSSMU_GPS_ExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRSSMU_GPS_ExampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRSSMU_GPS_ExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRSSMU_GPS_ExampleDlg::OnApply()
{
	ViStatus	rssmu_status;
	ViInt32		sync = 0;
	char		buffer[512];
	
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	GetDlgItem(IDAPPLY)->EnableWindow (FALSE);
	GetDlgItem(IDCANCEL)->EnableWindow (FALSE);
	
	UpdateData();

    /* Initialize the driver */
	rssmu_status = rssmu_init((char *) ((LPCTSTR) m_ResName), (int)(m_Query), (int)(m_Reset), &m_InstrSession);
	if (rssmu_status < 0)
	{
		AfxMessageBox ("Could not open the session!", MB_OK);
		cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );
		GetDlgItem(IDAPPLY)->EnableWindow ();
		GetDlgItem(IDCANCEL)->EnableWindow ();
		return;
	}

	//For Syncronisation 
	//Enable Operation Complete for STB Register
	FT_CHECKERR (rssmu_EventStatusEnable(m_InstrSession,1), "rssmu_EventStatusEnable");
	//Clear Status
	FT_CHECKERR (rssmu_ClearStatus(m_InstrSession),"rssmu_ClearStatus");

	do
	{
		Sleep (100);
		FT_CHECKERR (rssmu_getRegister (m_InstrSession, RSSMU_REGISTER_OPERATION, RSSMU_REGISTER_COND, &sync), "rssmu_StatusByteQuery");
	} while ((sync & 2) != 0);

	 int nav_value = (m_NavData > 1)? (m_NavData + 1): m_NavData;
	 FT_CHECKERR (rssmu_SetGPSDataSource (m_InstrSession, RSSMU_PATH_A, nav_value), "rssmu_SetGPSDataSource");

     FT_CHECKERR (rssmu_ConfigureGPSSatellite (m_InstrSession, RSSMU_PATH_A, 1, 1, m_SatId,
                                            RSSMU_GPS_RANGING_CODE_CA, m_SatTime,
                                            m_SatPower, m_SatDoppler), "rssmu_ConfigureGPSSatellite");

	FT_CHECKERR (rssmu_SetRFAmplitude (m_InstrSession, RSSMU_PATH_A, m_RFLevel), "rssmu_SetRFAmplitude");
	FT_CHECKERR (rssmu_SetRFFrequency (m_InstrSession, RSSMU_PATH_A, m_RFFreq), "rssmu_SetRFFrequency");
	FT_CHECKERR (rssmu_SetGPSState (m_InstrSession, RSSMU_PATH_A, m_GpsState), "rssmu_SetGPSState");

	FT_CHECKERR (rssmu_SetOutputState (m_InstrSession, RSSMU_PATH_A, m_RFState), "rssmu_SetOutputState");
	rssmu_close(m_InstrSession);

	GetDlgItem(IDAPPLY)->EnableWindow (TRUE);
	GetDlgItem(IDCANCEL)->EnableWindow (TRUE);
}


void CRSSMU_GPS_ExampleDlg::OnCancel() 
{
	if (m_InstrSession) rssmu_close (m_InstrSession);
	
	CDialog::OnCancel();
}

void CRSSMU_GPS_ExampleDlg::OnClose() 
{
	if (m_InstrSession) rssmu_close (m_InstrSession);
	
	CDialog::OnClose();
}
